diff --git a/package/boot/uboot-socfpga/Makefile b/package/boot/uboot-socfpga/Makefile
index 42fcb43..3fb017f 100644
--- a/package/boot/uboot-socfpga/Makefile
+++ b/package/boot/uboot-socfpga/Makefile
@@ -8,7 +8,7 @@
 include $(TOPDIR)/rules.mk
 
 PKG_NAME:=u-boot
-PKG_VERSION:=2016.03
+PKG_VERSION:=2016.05
 PKG_RELEASE:=1
 
 PKG_BUILD_DIR:=$(BUILD_DIR)/$(PKG_NAME)-$(BUILD_VARIANT)/$(PKG_NAME)-$(PKG_VERSION)
@@ -16,7 +16,7 @@ PKG_SOURCE:=$(PKG_NAME)-$(PKG_VERSION).tar.bz2
 PKG_SOURCE_URL:= \
 	http://mirror2.openwrt.org/sources \
 	ftp://ftp.denx.de/pub/u-boot
-PKG_MD5SUM:=973c1d896be751321cc3aafa564f64b2
+PKG_MD5SUM:=3a8613d753dfa707c937991a35404510
 
 PKG_LICENSE:=GPL-2.0 GPL-2.0+
 PKG_LICENSE_FILES:=Licenses/README
diff --git a/package/boot/uboot-socfpga/patches/0001-arm-socfpga-Drop-space-after-loadaddr-in-extra-env.patch b/package/boot/uboot-socfpga/patches/0001-arm-socfpga-Drop-space-after-loadaddr-in-extra-env.patch
deleted file mode 100644
index 261afef..0000000
--- a/package/boot/uboot-socfpga/patches/0001-arm-socfpga-Drop-space-after-loadaddr-in-extra-env.patch
+++ /dev/null
@@ -1,101 +0,0 @@
-From 04a4c90fee75c95130af1e40880c0927d56b0b61 Mon Sep 17 00:00:00 2001
-From: Marek Vasut <marex@denx.de>
-Date: Sun, 3 Apr 2016 19:11:12 +0200
-Subject: [PATCH 1/2] arm: socfpga: Drop space after 'loadaddr=' in extra env
-
-There is an incorrect space after loadaddr= in the extra environment,
-so drop it.
-
-Signed-off-by: Marek Vasut <marex@denx.de>
-Cc: Dinh Nguyen <dinguyen@opensource.altera.com>
-Cc: Chin Liang See <clsee@altera.com>
----
- include/configs/socfpga_arria5_socdk.h   | 2 +-
- include/configs/socfpga_cyclone5_socdk.h | 2 +-
- include/configs/socfpga_de0_nano_soc.h   | 2 +-
- include/configs/socfpga_sockit.h         | 2 +-
- include/configs/socfpga_socrates.h       | 2 +-
- include/configs/socfpga_sr1500.h         | 2 +-
- 6 files changed, 6 insertions(+), 6 deletions(-)
-
-diff --git a/include/configs/socfpga_arria5_socdk.h b/include/configs/socfpga_arria5_socdk.h
-index a0161bc..153f9f8 100644
---- a/include/configs/socfpga_arria5_socdk.h
-+++ b/include/configs/socfpga_arria5_socdk.h
-@@ -56,7 +56,7 @@
- /* Extra Environment */
- #define CONFIG_EXTRA_ENV_SETTINGS \
- 	"verify=n\0" \
--	"loadaddr= " __stringify(CONFIG_SYS_LOAD_ADDR) "\0" \
-+	"loadaddr=" __stringify(CONFIG_SYS_LOAD_ADDR) "\0" \
- 	"ramboot=setenv bootargs " CONFIG_BOOTARGS ";" \
- 		"bootm ${loadaddr} - ${fdt_addr}\0" \
- 	"bootimage=zImage\0" \
-diff --git a/include/configs/socfpga_cyclone5_socdk.h b/include/configs/socfpga_cyclone5_socdk.h
-index c4c4ecb..d7c339e 100644
---- a/include/configs/socfpga_cyclone5_socdk.h
-+++ b/include/configs/socfpga_cyclone5_socdk.h
-@@ -56,7 +56,7 @@
- /* Extra Environment */
- #define CONFIG_EXTRA_ENV_SETTINGS \
- 	"verify=n\0" \
--	"loadaddr= " __stringify(CONFIG_SYS_LOAD_ADDR) "\0" \
-+	"loadaddr=" __stringify(CONFIG_SYS_LOAD_ADDR) "\0" \
- 	"ramboot=setenv bootargs " CONFIG_BOOTARGS ";" \
- 		"bootm ${loadaddr} - ${fdt_addr}\0" \
- 	"bootimage=zImage\0" \
-diff --git a/include/configs/socfpga_de0_nano_soc.h b/include/configs/socfpga_de0_nano_soc.h
-index cbc7396..314b9bf 100644
---- a/include/configs/socfpga_de0_nano_soc.h
-+++ b/include/configs/socfpga_de0_nano_soc.h
-@@ -51,7 +51,7 @@
- 
- /* Extra Environment */
- #define CONFIG_EXTRA_ENV_SETTINGS \
--	"loadaddr= " __stringify(CONFIG_SYS_LOAD_ADDR) "\0" \
-+	"loadaddr=" __stringify(CONFIG_SYS_LOAD_ADDR) "\0" \
- 	"ramboot=setenv bootargs " CONFIG_BOOTARGS ";" \
- 		"bootm ${loadaddr} - ${fdt_addr}\0" \
- 	"bootimage=zImage\0" \
-diff --git a/include/configs/socfpga_sockit.h b/include/configs/socfpga_sockit.h
-index 95e7ba6..07cfcbf 100644
---- a/include/configs/socfpga_sockit.h
-+++ b/include/configs/socfpga_sockit.h
-@@ -52,7 +52,7 @@
- /* Extra Environment */
- #define CONFIG_EXTRA_ENV_SETTINGS \
- 	"verify=n\0" \
--	"loadaddr= " __stringify(CONFIG_SYS_LOAD_ADDR) "\0" \
-+	"loadaddr=" __stringify(CONFIG_SYS_LOAD_ADDR) "\0" \
- 	"ramboot=setenv bootargs " CONFIG_BOOTARGS ";" \
- 		"bootm ${loadaddr} - ${fdt_addr}\0" \
- 	"bootimage=zImage\0" \
-diff --git a/include/configs/socfpga_socrates.h b/include/configs/socfpga_socrates.h
-index c32a40a..02ea0c5 100644
---- a/include/configs/socfpga_socrates.h
-+++ b/include/configs/socfpga_socrates.h
-@@ -52,7 +52,7 @@
- /* Extra Environment */
- #define CONFIG_EXTRA_ENV_SETTINGS \
- 	"verify=n\0" \
--	"loadaddr= " __stringify(CONFIG_SYS_LOAD_ADDR) "\0" \
-+	"loadaddr=" __stringify(CONFIG_SYS_LOAD_ADDR) "\0" \
- 	"ramboot=setenv bootargs " CONFIG_BOOTARGS ";" \
- 		"bootm ${loadaddr} - ${fdt_addr}\0" \
- 	"bootimage=zImage\0" \
-diff --git a/include/configs/socfpga_sr1500.h b/include/configs/socfpga_sr1500.h
-index 6414eeb..e43b5cf 100644
---- a/include/configs/socfpga_sr1500.h
-+++ b/include/configs/socfpga_sr1500.h
-@@ -55,7 +55,7 @@
- 
- #define CONFIG_EXTRA_ENV_SETTINGS \
- 	"verify=n\0" \
--	"loadaddr= " __stringify(CONFIG_SYS_LOAD_ADDR) "\0" \
-+	"loadaddr=" __stringify(CONFIG_SYS_LOAD_ADDR) "\0" \
- 	"ramboot=setenv bootargs " CONFIG_BOOTARGS ";" \
- 		"bootm ${loadaddr} - ${fdt_addr}\0" \
- 	"bootimage=zImage\0" \
--- 
-2.8.0.rc3
-
diff --git a/package/boot/uboot-socfpga/patches/0002-arm-socfpga-Tweak-SoCkit-default-env-for-OpenWRT.patch b/package/boot/uboot-socfpga/patches/0001-arm-socfpga-Tweak-SoCkit-default-env-for-OpenWRT.patch
similarity index 91%
rename from package/boot/uboot-socfpga/patches/0002-arm-socfpga-Tweak-SoCkit-default-env-for-OpenWRT.patch
rename to package/boot/uboot-socfpga/patches/0001-arm-socfpga-Tweak-SoCkit-default-env-for-OpenWRT.patch
index 64ffea2..a46be2e 100644
--- a/package/boot/uboot-socfpga/patches/0002-arm-socfpga-Tweak-SoCkit-default-env-for-OpenWRT.patch
+++ b/package/boot/uboot-socfpga/patches/0001-arm-socfpga-Tweak-SoCkit-default-env-for-OpenWRT.patch
@@ -1,7 +1,7 @@
-From 3a0e4875b00e9e487b0081116a81ed17cfd5143f Mon Sep 17 00:00:00 2001
+From f17c641b74fa067c07295e20c4392664388ef7ac Mon Sep 17 00:00:00 2001
 From: Marek Vasut <marex@denx.de>
 Date: Sun, 3 Apr 2016 19:27:23 +0200
-Subject: [PATCH 2/2] arm: socfpga: Tweak SoCkit default env for OpenWRT
+Subject: [PATCH] arm: socfpga: Tweak SoCkit default env for OpenWRT
 
 Tweak the default environment on SoCFPGA SoCkit to match OpenWRT.
 This means switching to fitImage, which is already available, but
@@ -14,10 +14,10 @@ Signed-off-by: Marek Vasut <marex@denx.de>
  1 file changed, 6 insertions(+), 14 deletions(-)
 
 diff --git a/include/configs/socfpga_sockit.h b/include/configs/socfpga_sockit.h
-index 07cfcbf..5a90105 100644
+index 675f5d1..3111e46 100644
 --- a/include/configs/socfpga_sockit.h
 +++ b/include/configs/socfpga_sockit.h
-@@ -35,7 +35,7 @@
+@@ -19,7 +19,7 @@
  
  /* Booting Linux */
  #define CONFIG_BOOTDELAY	3
@@ -26,7 +26,7 @@ index 07cfcbf..5a90105 100644
  #define CONFIG_BOOTARGS		"console=ttyS0," __stringify(CONFIG_BAUDRATE)
  #define CONFIG_BOOTCOMMAND	"run mmcload; run mmcboot"
  #define CONFIG_LOADADDR		0x01000000
-@@ -51,28 +51,20 @@
+@@ -35,28 +35,20 @@
  
  /* Extra Environment */
  #define CONFIG_EXTRA_ENV_SETTINGS \
@@ -61,5 +61,5 @@ index 07cfcbf..5a90105 100644
  /* The rest of the configuration is shared */
  #include <configs/socfpga_common.h>
 -- 
-2.8.0.rc3
+2.8.1
 