diff --git a/package/firmware/ipq-wifi/Makefile b/package/firmware/ipq-wifi/Makefile
index a5555d5d7c..51da4bc465 100644
--- a/package/firmware/ipq-wifi/Makefile
+++ b/package/firmware/ipq-wifi/Makefile
@@ -17,7 +17,7 @@ endef
 # Please send a mail with your device-specific board files upstream.
 # You can find instructions and examples on the linux-wireless wiki:
 # <https://wireless.wiki.kernel.org/en/users/drivers/ath10k/boardfiles>
-ALLWIFIBOARDS:=zyxel_nbg6617 zyxel_wre6606
+ALLWIFIBOARDS:=
 ALLWIFIPACKAGES:=$(foreach BOARD,$(ALLWIFIBOARDS),ipq-wifi-$(BOARD))
 
 define Package/ipq-wifi-default
@@ -51,8 +51,6 @@ Don't install it for any other device!
   PREV_BOARD+=ipq-wifi-$(1)
 endef
 
-$(eval $(call generate-ipq-wifi-package,zyxel_wre6606,board-zyxel_wre6606.bin,ZyXEL WRE6606))
 #$(eval $(call generate-ipq-wifi-package,<devicename>,<filename>,<displayname>))
-$(eval $(call generate-ipq-wifi-package,zyxel_nbg6617,board-zyxel_nbg6617.bin,ZyXEL NBG6617))
 
 $(foreach PACKAGE,$(ALLWIFIPACKAGES),$(eval $(call BuildPackage,$(PACKAGE))))
diff --git a/package/firmware/ipq-wifi/board-zyxel_nbg6617.bin b/package/firmware/ipq-wifi/board-zyxel_nbg6617.bin
deleted file mode 100644
index ab4d43e8cbc949c06f74e332807b8d92239a7de0..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/package/firmware/ipq-wifi/board-zyxel_wre6606.bin b/package/firmware/ipq-wifi/board-zyxel_wre6606.bin
deleted file mode 100644
index 262c07b04a898eb8e2629d2fed11d517df96b3f6..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/target/linux/ipq40xx/image/Makefile b/target/linux/ipq40xx/image/Makefile
index 51a5be99af..8a42d3e780 100644
--- a/target/linux/ipq40xx/image/Makefile
+++ b/target/linux/ipq40xx/image/Makefile
@@ -223,7 +223,7 @@ define Device/zyxel_nbg6617
 #	this minimum-size. However, the larger image can be flashed both ways.
 	IMAGE/factory.bin := append-rootfs | pad-rootfs | pad-to 64k | check-size $$$$(ROOTFS_SIZE) | zyxel-ras-image separate-kernel
 	IMAGE/sysupgrade.bin/squashfs := append-rootfs | pad-rootfs | check-size $$$$(ROOTFS_SIZE) | sysupgrade-tar rootfs=$$$$@ | append-metadata
-	DEVICE_PACKAGES := ipq-wifi-zyxel_nbg6617 uboot-envtools
+	DEVICE_PACKAGES := uboot-envtools
 endef
 TARGET_DEVICES += zyxel_nbg6617
 
@@ -232,7 +232,6 @@ define Device/zyxel_wre6606
 	DEVICE_TITLE := ZyXEL WRE6606
 	DEVICE_DTS_CONFIG := config@4
 	DEVICE_DTS := qcom-ipq4018-wre6606
-	DEVICE_PACKAGES := ipq-wifi-zyxel_wre6606
 	IMAGES := sysupgrade.bin
 	IMAGE/sysupgrade.bin := append-kernel | append-rootfs | pad-rootfs | append-metadata
 endef